library(MLmetrics)
library(psych)
library(glmnet)
library(pROC)
library(missForest)
library(caret)
library(caTools)
library(survival)
library(stir)
library(glmnetUtils)
library(randomForest)
library(e1071)

############################################################################
# running post hoc sims to determine number of variables
############################################################################

x <- read.csv("Risk_Calculator_Revision.csv")
n <- nrow(x)

results1 <- matrix(NA,10000,12)
results2 <- matrix(NA,10000,12)
results3 <- matrix(NA,10000,12)
results4 <- matrix(NA,10000,12)
results5 <- matrix(NA,10000,12)
results6 <- matrix(NA,10000,12)
results7 <- matrix(NA,10000,12)
results8 <- matrix(NA,10000,12)
results9 <- matrix(NA,10000,12)
results10 <- matrix(NA,10000,12)
threshes <- NA

rf_picked1 <- "gaf001"
rf_picked2 <- c("gaf001","SIP004")
rf_picked3 <- c("gaf001","SIP004","SIP005")
rf_picked4 <- c("gaf001","SIP004","SIP005","PercentMarried")
rf_picked5 <- c("gaf001","SIP004","SIP005","PercentMarried","SIP014")
rf_picked6 <- c("gaf001","SIP004","SIP005","PercentMarried","SIP014","SIP035")
rf_picked7 <- c("gaf001","SIP004","SIP005","PercentMarried","SIP014","SIP035","trauma_T1")
rf_picked8 <- c("gaf001","SIP004","SIP005","PercentMarried","SIP014","SIP035","trauma_T1","fmem_a_ar_z")
rf_picked9 <- c("gaf001","SIP004","SIP005","PercentMarried","SIP014","SIP035","trauma_T1","fmem_a_ar_z","lan_a_ar_z")
rf_picked10 <- c("gaf001","SIP004","SIP005","PercentMarried","SIP014","SIP035","trauma_T1","fmem_a_ar_z","lan_a_ar_z","lan_s_ar_z")

for (dd in 1:10000) {

set.seed(dd+5)
key <- as.data.frame(cbind(runif(n),rep(1:10,n/10)))
key <- key[order(key$V1),]
rf_ridge_thresh <- NA

for (i in 1:10) {

xtr <- x[key[,2] != i,]
xte  <- x[key[,2] == i,]
ytr <- xtr$psTerminal - 1
yte <- xte$psTerminal - 1
xtr <- xtr[,2:ncol(xtr)]
xte  <- xte[,2:ncol(xte)]

#lambda1 <- cv.glmnet(x=as.matrix(xtr[,rf_picked1]),y=as.matrix(ytr),family="binomial",alpha=1)$lambda.min
lambda2 <- cv.glmnet(x=as.matrix(xtr[,rf_picked2]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda3 <- cv.glmnet(x=as.matrix(xtr[,rf_picked3]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda4 <- cv.glmnet(x=as.matrix(xtr[,rf_picked4]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda5 <- cv.glmnet(x=as.matrix(xtr[,rf_picked5]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda6 <- cv.glmnet(x=as.matrix(xtr[,rf_picked6]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda7 <- cv.glmnet(x=as.matrix(xtr[,rf_picked7]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda8 <- cv.glmnet(x=as.matrix(xtr[,rf_picked8]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda9 <- cv.glmnet(x=as.matrix(xtr[,rf_picked9]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
lambda10 <- cv.glmnet(x=as.matrix(xtr[,rf_picked10]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
mod_ridge1 <- glm(ytr~xtr[,rf_picked1],family="binomial")
mod_ridge2 <- glmnet(x=as.matrix(xtr[,rf_picked2]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda2)
mod_ridge3 <- glmnet(x=as.matrix(xtr[,rf_picked3]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda3)
mod_ridge4 <- glmnet(x=as.matrix(xtr[,rf_picked4]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda4)
mod_ridge5 <- glmnet(x=as.matrix(xtr[,rf_picked5]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda5)
mod_ridge6 <- glmnet(x=as.matrix(xtr[,rf_picked6]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda6)
mod_ridge7 <- glmnet(x=as.matrix(xtr[,rf_picked7]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda7)
mod_ridge8 <- glmnet(x=as.matrix(xtr[,rf_picked8]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda8)
mod_ridge9 <- glmnet(x=as.matrix(xtr[,rf_picked9]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda9)
mod_ridge10 <- glmnet(x=as.matrix(xtr[,rf_picked10]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda10)
probs1 <- predict(mod_ridge1,newdata=as.data.frame(xtr[,rf_picked1]),type="response")
probs2 <- predict(mod_ridge2,newx=as.matrix(xtr[,rf_picked2]),type="response")
probs3 <- predict(mod_ridge3,newx=as.matrix(xtr[,rf_picked3]),type="response")
probs4 <- predict(mod_ridge4,newx=as.matrix(xtr[,rf_picked4]),type="response")
probs5 <- predict(mod_ridge5,newx=as.matrix(xtr[,rf_picked5]),type="response")
probs6 <- predict(mod_ridge6,newx=as.matrix(xtr[,rf_picked6]),type="response")
probs7 <- predict(mod_ridge7,newx=as.matrix(xtr[,rf_picked7]),type="response")
probs8 <- predict(mod_ridge8,newx=as.matrix(xtr[,rf_picked8]),type="response")
probs9 <- predict(mod_ridge9,newx=as.matrix(xtr[,rf_picked9]),type="response")
probs10 <- predict(mod_ridge10,newx=as.matrix(xtr[,rf_picked10]),type="response")
thresh_ridge1 <- pROC::coords(pROC::roc(ytr~as.numeric(probs1)),x="best")[1]
thresh_ridge2 <- pROC::coords(pROC::roc(ytr~as.numeric(probs2)),x="best")[1]
thresh_ridge3 <- pROC::coords(pROC::roc(ytr~as.numeric(probs3)),x="best")[1]
thresh_ridge4 <- pROC::coords(pROC::roc(ytr~as.numeric(probs4)),x="best")[1]
thresh_ridge5 <- pROC::coords(pROC::roc(ytr~as.numeric(probs5)),x="best")[1]
thresh_ridge6 <- pROC::coords(pROC::roc(ytr~as.numeric(probs6)),x="best")[1]
thresh_ridge7 <- pROC::coords(pROC::roc(ytr~as.numeric(probs7)),x="best")[1]
thresh_ridge8 <- pROC::coords(pROC::roc(ytr~as.numeric(probs8)),x="best")[1]
thresh_ridge9 <- pROC::coords(pROC::roc(ytr~as.numeric(probs9)),x="best")[1]
thresh_ridge10 <- pROC::coords(pROC::roc(ytr~as.numeric(probs10)),x="best")[1]
mod_ridge1 <- glm(yte~xte[,rf_picked1],family="binomial")
pred1 <- predict(mod_ridge1, newdata=as.data.frame(xte[,rf_picked1]),type="response")
pred2 <- predict(mod_ridge2, newx=as.matrix(xte[,rf_picked2]),type="response")
pred3 <- predict(mod_ridge3, newx=as.matrix(xte[,rf_picked3]),type="response")
pred4 <- predict(mod_ridge4, newx=as.matrix(xte[,rf_picked4]),type="response")
pred5 <- predict(mod_ridge5, newx=as.matrix(xte[,rf_picked5]),type="response")
pred6 <- predict(mod_ridge6, newx=as.matrix(xte[,rf_picked6]),type="response")
pred7 <- predict(mod_ridge7, newx=as.matrix(xte[,rf_picked7]),type="response")
pred8 <- predict(mod_ridge8, newx=as.matrix(xte[,rf_picked8]),type="response")
pred9 <- predict(mod_ridge9, newx=as.matrix(xte[,rf_picked9]),type="response")
pred10 <- predict(mod_ridge10, newx=as.matrix(xte[,rf_picked10]),type="response")
for (j in 1:length(pred1)) {if (pred1[j] > thresh_ridge1) {pred1[j] <- 1}
if (pred1[j] < thresh_ridge1) {pred1[j] <- 0}}
for (j in 1:length(pred2)) {if (pred2[j] > thresh_ridge2) {pred2[j] <- 1}
if (pred2[j] < thresh_ridge2) {pred2[j] <- 0}}
for (j in 1:length(pred3)) {if (pred3[j] > thresh_ridge3) {pred3[j] <- 1}
if (pred3[j] < thresh_ridge3) {pred3[j] <- 0}}
for (j in 1:length(pred4)) {if (pred4[j] > thresh_ridge4) {pred4[j] <- 1}
if (pred4[j] < thresh_ridge4) {pred4[j] <- 0}}
for (j in 1:length(pred5)) {if (pred5[j] > thresh_ridge5) {pred5[j] <- 1}
if (pred5[j] < thresh_ridge5) {pred5[j] <- 0}}
for (j in 1:length(pred6)) {if (pred6[j] > thresh_ridge6) {pred6[j] <- 1}
if (pred6[j] < thresh_ridge6) {pred6[j] <- 0}}
for (j in 1:length(pred7)) {if (pred7[j] > thresh_ridge7) {pred7[j] <- 1}
if (pred7[j] < thresh_ridge7) {pred7[j] <- 0}}
for (j in 1:length(pred8)) {if (pred8[j] > thresh_ridge8) {pred8[j] <- 1}
if (pred8[j] < thresh_ridge8) {pred8[j] <- 0}}
for (j in 1:length(pred9)) {if (pred9[j] > thresh_ridge9) {pred9[j] <- 1}
if (pred9[j] < thresh_ridge9) {pred9[j] <- 0}}
for (j in 1:length(pred10)) {if (pred10[j] > thresh_ridge10) {pred10[j] <- 1}
if (pred10[j] < thresh_ridge10) {pred10[j] <- 0}}

if (i == 1) {
pred11 <- cbind(pred1,yte)
pred12 <- cbind(pred2,yte)
pred13 <- cbind(pred3,yte)
pred14 <- cbind(pred4,yte)
pred15 <- cbind(pred5,yte)
pred16 <- cbind(pred6,yte)
pred17 <- cbind(pred7,yte)
pred18 <- cbind(pred8,yte)
pred19 <- cbind(pred9,yte)
pred110 <- cbind(pred10,yte)}

if (i == 2) {
pred21 <- cbind(pred1,yte)
pred22 <- cbind(pred2,yte)
pred23 <- cbind(pred3,yte)
pred24 <- cbind(pred4,yte)
pred25 <- cbind(pred5,yte)
pred26 <- cbind(pred6,yte)
pred27 <- cbind(pred7,yte)
pred28 <- cbind(pred8,yte)
pred29 <- cbind(pred9,yte)
pred210 <- cbind(pred10,yte)}

if (i == 3) {
pred31 <- cbind(pred1,yte)
pred32 <- cbind(pred2,yte)
pred33 <- cbind(pred3,yte)
pred34 <- cbind(pred4,yte)
pred35 <- cbind(pred5,yte)
pred36 <- cbind(pred6,yte)
pred37 <- cbind(pred7,yte)
pred38 <- cbind(pred8,yte)
pred39 <- cbind(pred9,yte)
pred310 <- cbind(pred10,yte)}

if (i== 4) {
pred41 <- cbind(pred1,yte)
pred42 <- cbind(pred2,yte)
pred43 <- cbind(pred3,yte)
pred44 <- cbind(pred4,yte)
pred45 <- cbind(pred5,yte)
pred46 <- cbind(pred6,yte)
pred47 <- cbind(pred7,yte)
pred48 <- cbind(pred8,yte)
pred49 <- cbind(pred9,yte)
pred410 <- cbind(pred10,yte)}

if (i== 5) {
pred51 <- cbind(pred1,yte)
pred52 <- cbind(pred2,yte)
pred53 <- cbind(pred3,yte)
pred54 <- cbind(pred4,yte)
pred55 <- cbind(pred5,yte)
pred56 <- cbind(pred6,yte)
pred57 <- cbind(pred7,yte)
pred58 <- cbind(pred8,yte)
pred59 <- cbind(pred9,yte)
pred510 <- cbind(pred10,yte)}

if (i== 6) {
pred61 <- cbind(pred1,yte)
pred62 <- cbind(pred2,yte)
pred63 <- cbind(pred3,yte)
pred64 <- cbind(pred4,yte)
pred65 <- cbind(pred5,yte)
pred66 <- cbind(pred6,yte)
pred67 <- cbind(pred7,yte)
pred68 <- cbind(pred8,yte)
pred69 <- cbind(pred9,yte)
pred610 <- cbind(pred10,yte)}

if (i== 7) {
pred71 <- cbind(pred1,yte)
pred72 <- cbind(pred2,yte)
pred73 <- cbind(pred3,yte)
pred74 <- cbind(pred4,yte)
pred75 <- cbind(pred5,yte)
pred76 <- cbind(pred6,yte)
pred77 <- cbind(pred7,yte)
pred78 <- cbind(pred8,yte)
pred79 <- cbind(pred9,yte)
pred710 <- cbind(pred10,yte)}

if (i== 8) {
pred81 <- cbind(pred1,yte)
pred82 <- cbind(pred2,yte)
pred83 <- cbind(pred3,yte)
pred84 <- cbind(pred4,yte)
pred85 <- cbind(pred5,yte)
pred86 <- cbind(pred6,yte)
pred87 <- cbind(pred7,yte)
pred88 <- cbind(pred8,yte)
pred89 <- cbind(pred9,yte)
pred810 <- cbind(pred10,yte)}

if (i== 9) {
pred91 <- cbind(pred1,yte)
pred92 <- cbind(pred2,yte)
pred93 <- cbind(pred3,yte)
pred94 <- cbind(pred4,yte)
pred95 <- cbind(pred5,yte)
pred96 <- cbind(pred6,yte)
pred97 <- cbind(pred7,yte)
pred98 <- cbind(pred8,yte)
pred99 <- cbind(pred9,yte)
pred910 <- cbind(pred10,yte)}

if (i== 10) {
pred101 <- cbind(pred1,yte)
pred102 <- cbind(pred2,yte)
pred103 <- cbind(pred3,yte)
pred104 <- cbind(pred4,yte)
pred105 <- cbind(pred5,yte)
pred106 <- cbind(pred6,yte)
pred107 <- cbind(pred7,yte)
pred108 <- cbind(pred8,yte)
pred109 <- cbind(pred9,yte)
pred1010 <- cbind(pred10,yte)}

}

threshes <- c(threshes,thresh_ridge1,thresh_ridge2,thresh_ridge3,thresh_ridge4,thresh_ridge5,thresh_ridge6,thresh_ridge7,thresh_ridge8,thresh_ridge9,thresh_ridge10)

pred1<- rbind(pred11,pred21,pred31,pred41,pred51,pred61,pred71,pred81,pred91,pred101)
pred2<- rbind(pred12,pred22,pred32,pred42,pred52,pred62,pred72,pred82,pred92,pred102)
pred3<- rbind(pred13,pred23,pred33,pred43,pred53,pred63,pred73,pred83,pred93,pred103)
pred4<- rbind(pred14,pred24,pred34,pred44,pred54,pred64,pred74,pred84,pred94,pred104)
pred5<- rbind(pred15,pred25,pred35,pred45,pred55,pred65,pred75,pred85,pred95,pred105)
pred6<- rbind(pred16,pred26,pred36,pred46,pred56,pred66,pred76,pred86,pred96,pred106)
pred7<- rbind(pred17,pred27,pred37,pred47,pred57,pred67,pred77,pred87,pred97,pred107)
pred8<- rbind(pred18,pred28,pred38,pred48,pred58,pred68,pred78,pred88,pred98,pred108)
pred9<- rbind(pred19,pred29,pred39,pred49,pred59,pred69,pred79,pred89,pred99,pred109)
pred10<- rbind(pred110,pred210,pred310,pred410,pred510,pred610,pred710,pred810,pred910,pred1010)

results1[dd,1] <- MLmetrics::AUC(pred1[,1], pred1[,2])
results2[dd,1] <- MLmetrics::AUC(pred2[,1], pred2[,2])
results3[dd,1] <- MLmetrics::AUC(pred3[,1], pred3[,2])
results4[dd,1] <- MLmetrics::AUC(pred4[,1], pred4[,2])
results5[dd,1] <- MLmetrics::AUC(pred5[,1], pred5[,2])
results6[dd,1] <- MLmetrics::AUC(pred6[,1], pred6[,2])
results7[dd,1] <- MLmetrics::AUC(pred7[,1], pred7[,2])
results8[dd,1] <- MLmetrics::AUC(pred8[,1], pred8[,2])
results9[dd,1] <- MLmetrics::AUC(pred9[,1], pred9[,2])
results10[dd,1] <- MLmetrics::AUC(pred10[,1], pred10[,2])

results1[dd,2:12] <- confusionMatrix(data=as.factor(pred1[,1]), as.factor(pred1[,2]))$byClass
results2[dd,2:12] <- confusionMatrix(data=as.factor(pred2[,1]), as.factor(pred2[,2]))$byClass
results3[dd,2:12] <- confusionMatrix(data=as.factor(pred3[,1]), as.factor(pred3[,2]))$byClass
results4[dd,2:12] <- confusionMatrix(data=as.factor(pred4[,1]), as.factor(pred4[,2]))$byClass
results5[dd,2:12] <- confusionMatrix(data=as.factor(pred5[,1]), as.factor(pred5[,2]))$byClass
results6[dd,2:12] <- confusionMatrix(data=as.factor(pred6[,1]), as.factor(pred6[,2]))$byClass
results7[dd,2:12] <- confusionMatrix(data=as.factor(pred7[,1]), as.factor(pred7[,2]))$byClass
results8[dd,2:12] <- confusionMatrix(data=as.factor(pred8[,1]), as.factor(pred8[,2]))$byClass
results9[dd,2:12] <- confusionMatrix(data=as.factor(pred9[,1]), as.factor(pred9[,2]))$byClass
results10[dd,2:12] <- confusionMatrix(data=as.factor(pred10[,1]), as.factor(pred10[,2]))$byClass

}

res <- rbind(
results1,
results2,
results3,
results4,
results5,
results6,
results7,
results8,
results9,
results10)

res <- data.frame(res,c(rep(1,10000),rep(2,10000),rep(3,10000),rep(4,10000),rep(5,10000),rep(6,10000),rep(7,10000),rep(8,10000),rep(9,10000),rep(10,10000)))

threshes <- data.frame(na.omit(threshes),rep(1:10,10000))

write.csv(res,"Risk_Calc_results_5September2020.csv",na="",row.names=FALSE)
write.csv(threshes,"Risk_Calc_thresholds.csv",na="",row.names=FALSE)
