
library(MLmetrics)
library(psych)
library(glmnet)
library(pROC)
library(missForest)
library(caret)
library(caTools)
library(survival)
library(stir)
library(glmnetUtils)
library(randomForest)
library(e1071)

############################################################################
# for revision (simulations)
############################################################################

x <- read.csv("Risk_Calculator_Revision.csv")
#x <- x[is.na(x$psTerminal)==FALSE,]
n <- nrow(x)
#nam <- readLines("names11.txt",skip=0)
#x <- x[,nam]

#set.seed(2)
#for (i in 1:ncol(x)) {if (length(unique(x[,i])) < 6) {x[,i] <- as.factor(x[,i])}}
#x <- missForest(x)$ximp
#for (i in 1:ncol(x)) {x[,i] <- as.numeric(x[,i])}
# write.csv(x,"Risk_Calculator_Revision.csv",na="",row.names=FALSE)
results_lasso_rf <- matrix(NA,1000,12)
results_lasso_svm <- matrix(NA,1000,12)
results_lasso_ridge <- matrix(NA,1000,12)
results_stir_rf <- matrix(NA,1000,12)
results_stir_svm <- matrix(NA,1000,12)
results_stir_ridge <- matrix(NA,1000,12)
results_rf_rf <- matrix(NA,1000,12)
results_rf_svm <- matrix(NA,1000,12)
results_rf_ridge <- matrix(NA,1000,12)
lasso_picked <- NA
rf_picked <- NA
stir_picked <- NA

for (dd in 1:1000) {

key <- as.data.frame(cbind(runif(n),rep(1:10,n/10)))
key <- key[order(key$V1),]
lasso_ridge_thresh <- NA
lasso_svm_thresh <- NA
lasso_rf_thresh <- NA
stir_ridge_thresh <- NA
stir_svm_thresh <- NA
stir_rf_thresh <- NA
rf_ridge_thresh <- NA
rf_svm_thresh <- NA
rf_rf_thresh <- NA

for (i in 1:10) {

xtr <- x[key[,2] != i,]
xte  <- x[key[,2] == i,]
ytr <- xtr$psTerminal - 1
yte <- xte$psTerminal - 1
xtr <- xtr[,2:ncol(xtr)]
xte  <- xte[,2:ncol(xte)]

lambda <- cv.glmnet(x=as.matrix(xtr),y=as.matrix(ytr),family="binomial",alpha=1)$lambda.min
mod1 <- glmnet(x=as.matrix(xtr),y=as.matrix(ytr),family="binomial",alpha=1,lambda=lambda)
res <- as.matrix(coef(mod1))
lasso_picked0 <- rownames(res)[res!=0]
lasso_picked <- c(lasso_picked,lasso_picked0)

modrf <- randomForest(x=as.matrix(xtr),y=as.factor(ytr))
imp <- as.data.frame(modrf$importance)
rfm <- mean(as.matrix(imp))
rf_picked0 <- rownames(imp)[imp > rfm]
rf_picked <- c(rf_picked,rf_picked0)

RF.method = "multisurf"
metric <- "manhattan"
neighbors <- find.neighbors(xtr, ytr, k = 0, method = RF.method)
res <- stir(xtr, neighbors, k = 0, metric = metric, method = RF.method)$STIR_T
stir_picked0 <- rownames(res[res$t.pval < 0.05,])
stir_picked <- c(stir_picked,stir_picked0)

# lasso then ridge
lambda <- cv.glmnet(x=as.matrix(xtr[,lasso_picked0[-1]]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
mod_ridge <- glmnet(x=as.matrix(xtr[,lasso_picked0[-1]]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda)
probs <- predict(mod_ridge,newx=as.matrix(xtr[,lasso_picked0[-1]]),type="response")
thresh_ridge <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
lasso_ridge_thresh <- c(lasso_ridge_thresh,thresh_ridge)
pred <- predict(mod_ridge, newx=as.matrix(xte[,lasso_picked0[-1]]),type="response")
for (j in 1:length(pred)) {
if (pred[j] > thresh_ridge) {pred[j] <- 1}
if (pred[j] < thresh_ridge) {pred[j] <- 0}}
if (i == 1) {pred_lasso_ridge1 <- cbind(pred,yte)}
if (i == 2) {pred_lasso_ridge2 <- cbind(pred,yte)}
if (i == 3) {pred_lasso_ridge3 <- cbind(pred,yte)}
if (i == 4) {pred_lasso_ridge4 <- cbind(pred,yte)}
if (i == 5) {pred_lasso_ridge5 <- cbind(pred,yte)}
if (i == 6) {pred_lasso_ridge6 <- cbind(pred,yte)}
if (i == 7) {pred_lasso_ridge7 <- cbind(pred,yte)}
if (i == 8) {pred_lasso_ridge8 <- cbind(pred,yte)}
if (i == 9) {pred_lasso_ridge9 <- cbind(pred,yte)}
if (i == 10) {pred_lasso_ridge10 <- cbind(pred,yte)}

# lasso then svm
mod_svm <- svm(x=as.matrix(xtr[,lasso_picked0[-1]]),y=as.factor(ytr),probability=TRUE)
probs <- attr(predict(mod_svm, newdata=as.matrix(xtr[,lasso_picked0[-1]]),probability=TRUE),"probabilities")[,2]
thresh_svm <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
lasso_svm_thresh <- c(lasso_svm_thresh,thresh_svm)
pred <- attr(predict(mod_svm, newdata=as.matrix(xte[,lasso_picked0[-1]]),probability=TRUE),"probabilities")[,2]
for (j in 1:length(pred)) {
if (pred[j] >= thresh_svm) {pred[j] <- 1}
if (pred[j] < thresh_svm) {pred[j] <- 0}}
if (i == 1) {pred_lasso_svm1 <- cbind(pred,yte)}
if (i == 2) {pred_lasso_svm2 <- cbind(pred,yte)}
if (i == 3) {pred_lasso_svm3 <- cbind(pred,yte)}
if (i == 4) {pred_lasso_svm4 <- cbind(pred,yte)}
if (i == 5) {pred_lasso_svm5 <- cbind(pred,yte)}
if (i == 6) {pred_lasso_svm6 <- cbind(pred,yte)}
if (i == 7) {pred_lasso_svm7 <- cbind(pred,yte)}
if (i == 8) {pred_lasso_svm8 <- cbind(pred,yte)}
if (i == 9) {pred_lasso_svm9 <- cbind(pred,yte)}
if (i == 10) {pred_lasso_svm10 <- cbind(pred,yte)}

# lasso then rf
mod_rf <- randomForest(x=as.matrix(xtr[,lasso_picked0[-1]]),y=as.factor(ytr))
probs <- predict(mod_rf, newdata=as.matrix(xtr[,lasso_picked0[-1]]),type="prob")[,2]
thresh_rf <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
lasso_rf_thresh <- c(lasso_rf_thresh,thresh_rf)
pred <- predict(mod_rf, newdata=as.matrix(xte[,lasso_picked0[-1]]),type="prob")[,2]
for (j in 1:length(pred)) {
if (pred[j] >= thresh_rf) {pred[j] <- 1}
if (pred[j] < thresh_rf) {pred[j] <- 0}}
if (i == 1) {pred_lasso_rf1 <- cbind(pred,yte)}
if (i == 2) {pred_lasso_rf2 <- cbind(pred,yte)}
if (i == 3) {pred_lasso_rf3 <- cbind(pred,yte)}
if (i == 4) {pred_lasso_rf4 <- cbind(pred,yte)}
if (i == 5) {pred_lasso_rf5 <- cbind(pred,yte)}
if (i == 6) {pred_lasso_rf6 <- cbind(pred,yte)}
if (i == 7) {pred_lasso_rf7 <- cbind(pred,yte)}
if (i == 8) {pred_lasso_rf8 <- cbind(pred,yte)}
if (i == 9) {pred_lasso_rf9 <- cbind(pred,yte)}
if (i == 10) {pred_lasso_rf10 <- cbind(pred,yte)}

# stir then ridge
lambda <- cv.glmnet(x=as.matrix(xtr[,stir_picked0]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
mod_ridge <- glmnet(x=as.matrix(xtr[,stir_picked0]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda)
probs <- predict(mod_ridge,newx=as.matrix(xtr[,stir_picked0]),type="response")
thresh_ridge <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
stir_ridge_thresh <- c(stir_ridge_thresh,thresh_ridge)
pred <- predict(mod_ridge, newx=as.matrix(xte[,stir_picked0]),type="response")
for (j in 1:length(pred)) {
if (pred[j] > thresh_ridge) {pred[j] <- 1}
if (pred[j] < thresh_ridge) {pred[j] <- 0}}
if (i == 1) {pred_stir_ridge1 <- cbind(pred,yte)}
if (i == 2) {pred_stir_ridge2 <- cbind(pred,yte)}
if (i == 3) {pred_stir_ridge3 <- cbind(pred,yte)}
if (i == 4) {pred_stir_ridge4 <- cbind(pred,yte)}
if (i == 5) {pred_stir_ridge5 <- cbind(pred,yte)}
if (i == 6) {pred_stir_ridge6 <- cbind(pred,yte)}
if (i == 7) {pred_stir_ridge7 <- cbind(pred,yte)}
if (i == 8) {pred_stir_ridge8 <- cbind(pred,yte)}
if (i == 9) {pred_stir_ridge9 <- cbind(pred,yte)}
if (i == 10) {pred_stir_ridge10 <- cbind(pred,yte)}

# stir then svm
mod_svm <- svm(x=as.matrix(xtr[,stir_picked0]),y=as.factor(ytr),probability=TRUE)
probs <- attr(predict(mod_svm, newdata=as.matrix(xtr[,stir_picked0]),probability=TRUE),"probabilities")[,2]
thresh_svm <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
stir_svm_thresh <- c(stir_svm_thresh,thresh_svm)
pred <- attr(predict(mod_svm, newdata=as.matrix(xte[,stir_picked0]),probability=TRUE),"probabilities")[,2]
for (j in 1:length(pred)) {
if (pred[j] >= thresh_svm) {pred[j] <- 1}
if (pred[j] < thresh_svm) {pred[j] <- 0}}
if (i == 1) {pred_stir_svm1 <- cbind(pred,yte)}
if (i == 2) {pred_stir_svm2 <- cbind(pred,yte)}
if (i == 3) {pred_stir_svm3 <- cbind(pred,yte)}
if (i == 4) {pred_stir_svm4 <- cbind(pred,yte)}
if (i == 5) {pred_stir_svm5 <- cbind(pred,yte)}
if (i == 6) {pred_stir_svm6 <- cbind(pred,yte)}
if (i == 7) {pred_stir_svm7 <- cbind(pred,yte)}
if (i == 8) {pred_stir_svm8 <- cbind(pred,yte)}
if (i == 9) {pred_stir_svm9 <- cbind(pred,yte)}
if (i == 10) {pred_stir_svm10 <- cbind(pred,yte)}

# stir then rf
mod_rf <- randomForest(x=as.matrix(xtr[,stir_picked0]),y=as.factor(ytr))
probs <- predict(mod_rf, newdata=as.matrix(xtr[,stir_picked0]),type="prob")[,2]
thresh_rf <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
stir_rf_thresh <- c(stir_rf_thresh,thresh_rf)
pred <- predict(mod_rf, newdata=as.matrix(xte[,stir_picked0]),type="prob")[,2]
for (j in 1:length(pred)) {
if (pred[j] >= thresh_rf) {pred[j] <- 1}
if (pred[j] < thresh_rf) {pred[j] <- 0}}
if (i == 1) {pred_stir_rf1 <- cbind(pred,yte)}
if (i == 2) {pred_stir_rf2 <- cbind(pred,yte)}
if (i == 3) {pred_stir_rf3 <- cbind(pred,yte)}
if (i == 4) {pred_stir_rf4 <- cbind(pred,yte)}
if (i == 5) {pred_stir_rf5 <- cbind(pred,yte)}
if (i == 6) {pred_stir_rf6 <- cbind(pred,yte)}
if (i == 7) {pred_stir_rf7 <- cbind(pred,yte)}
if (i == 8) {pred_stir_rf8 <- cbind(pred,yte)}
if (i == 9) {pred_stir_rf9 <- cbind(pred,yte)}
if (i == 10) {pred_stir_rf10 <- cbind(pred,yte)}

# rf then ridge
lambda <- cv.glmnet(x=as.matrix(xtr[,rf_picked0]),y=as.matrix(ytr),family="binomial",alpha=0)$lambda.min
mod_ridge <- glmnet(x=as.matrix(xtr[,rf_picked0]),y=as.matrix(ytr),family="binomial",alpha=0,lambda=lambda)
probs <- predict(mod_ridge,newx=as.matrix(xtr[,rf_picked0]),type="response")
thresh_ridge <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
rf_ridge_thresh <- c(rf_ridge_thresh,thresh_ridge)
pred <- predict(mod_ridge, newx=as.matrix(xte[,rf_picked0]),type="response")
for (j in 1:length(pred)) {
if (pred[j] > thresh_ridge) {pred[j] <- 1}
if (pred[j] < thresh_ridge) {pred[j] <- 0}}
if (i == 1) {pred_rf_ridge1 <- cbind(pred,yte)}
if (i == 2) {pred_rf_ridge2 <- cbind(pred,yte)}
if (i == 3) {pred_rf_ridge3 <- cbind(pred,yte)}
if (i == 4) {pred_rf_ridge4 <- cbind(pred,yte)}
if (i == 5) {pred_rf_ridge5 <- cbind(pred,yte)}
if (i == 6) {pred_rf_ridge6 <- cbind(pred,yte)}
if (i == 7) {pred_rf_ridge7 <- cbind(pred,yte)}
if (i == 8) {pred_rf_ridge8 <- cbind(pred,yte)}
if (i == 9) {pred_rf_ridge9 <- cbind(pred,yte)}
if (i == 10) {pred_rf_ridge10 <- cbind(pred,yte)}

# rf then svm
mod_svm <- svm(x=as.matrix(xtr[,rf_picked0]),y=as.factor(ytr),probability=TRUE)
probs <- attr(predict(mod_svm, newdata=as.matrix(xtr[,rf_picked0]),probability=TRUE),"probabilities")[,2]
thresh_svm <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
rf_svm_thresh <- c(rf_svm_thresh,thresh_svm)
pred <- attr(predict(mod_svm, newdata=as.matrix(xte[,rf_picked0]),probability=TRUE),"probabilities")[,2]
for (j in 1:length(pred)) {
if (pred[j] >= thresh_svm) {pred[j] <- 1}
if (pred[j] < thresh_svm) {pred[j] <- 0}}
if (i == 1) {pred_rf_svm1 <- cbind(pred,yte)}
if (i == 2) {pred_rf_svm2 <- cbind(pred,yte)}
if (i == 3) {pred_rf_svm3 <- cbind(pred,yte)}
if (i == 4) {pred_rf_svm4 <- cbind(pred,yte)}
if (i == 5) {pred_rf_svm5 <- cbind(pred,yte)}
if (i == 6) {pred_rf_svm6 <- cbind(pred,yte)}
if (i == 7) {pred_rf_svm7 <- cbind(pred,yte)}
if (i == 8) {pred_rf_svm8 <- cbind(pred,yte)}
if (i == 9) {pred_rf_svm9 <- cbind(pred,yte)}
if (i == 10) {pred_rf_svm10 <- cbind(pred,yte)}

# rf then rf
mod_rf <- randomForest(x=as.matrix(xtr[,rf_picked0]),y=as.factor(ytr))
probs <- predict(mod_rf, newdata=as.matrix(xtr[,rf_picked0]),type="prob")[,2]
thresh_rf <- pROC::coords(pROC::roc(ytr~as.numeric(probs)),x="best")[1]
rf_rf_thresh <- c(rf_rf_thresh,thresh_rf)
pred <- predict(mod_rf, newdata=as.matrix(xte[,rf_picked0]),type="prob")[,2]
for (j in 1:length(pred)) {
if (pred[j] >= thresh_rf) {pred[j] <- 1}
if (pred[j] < thresh_rf) {pred[j] <- 0}}
if (i == 1) {pred_rf_rf1 <- cbind(pred,yte)}
if (i == 2) {pred_rf_rf2 <- cbind(pred,yte)}
if (i == 3) {pred_rf_rf3 <- cbind(pred,yte)}
if (i == 4) {pred_rf_rf4 <- cbind(pred,yte)}
if (i == 5) {pred_rf_rf5 <- cbind(pred,yte)}
if (i == 6) {pred_rf_rf6 <- cbind(pred,yte)}
if (i == 7) {pred_rf_rf7 <- cbind(pred,yte)}
if (i == 8) {pred_rf_rf8 <- cbind(pred,yte)}
if (i == 9) {pred_rf_rf9 <- cbind(pred,yte)}
if (i == 10) {pred_rf_rf10 <- cbind(pred,yte)}

}

pred_lasso_ridge <- rbind(pred_lasso_ridge1,pred_lasso_ridge2,pred_lasso_ridge3,pred_lasso_ridge4,pred_lasso_ridge5,pred_lasso_ridge6,pred_lasso_ridge7,pred_lasso_ridge8,pred_lasso_ridge9,pred_lasso_ridge10)
pred_lasso_svm <- rbind(pred_lasso_svm1,pred_lasso_svm2,pred_lasso_svm3,pred_lasso_svm4,pred_lasso_svm5,pred_lasso_svm6,pred_lasso_svm7,pred_lasso_svm8,pred_lasso_svm9,pred_lasso_svm10)
pred_lasso_rf <- rbind(pred_lasso_rf1,pred_lasso_rf2,pred_lasso_rf3,pred_lasso_rf4,pred_lasso_rf5,pred_lasso_rf6,pred_lasso_rf7,pred_lasso_rf8,pred_lasso_rf9,pred_lasso_rf10)

pred_stir_ridge <- rbind(pred_stir_ridge1,pred_stir_ridge2,pred_stir_ridge3,pred_stir_ridge4,pred_stir_ridge5,pred_stir_ridge6,pred_stir_ridge7,pred_stir_ridge8,pred_stir_ridge9,pred_stir_ridge10)
pred_stir_svm <- rbind(pred_stir_svm1,pred_stir_svm2,pred_stir_svm3,pred_stir_svm4,pred_stir_svm5,pred_stir_svm6,pred_stir_svm7,pred_stir_svm8,pred_stir_svm9,pred_stir_svm10)
pred_stir_rf <- rbind(pred_stir_rf1,pred_stir_rf2,pred_stir_rf3,pred_stir_rf4,pred_stir_rf5,pred_stir_rf6,pred_stir_rf7,pred_stir_rf8,pred_stir_rf9,pred_stir_rf10)

pred_rf_ridge <- rbind(pred_rf_ridge1,pred_rf_ridge2,pred_rf_ridge3,pred_rf_ridge4,pred_rf_ridge5,pred_rf_ridge6,pred_rf_ridge7,pred_rf_ridge8,pred_rf_ridge9,pred_rf_ridge10)
pred_rf_svm <- rbind(pred_rf_svm1,pred_rf_svm2,pred_rf_svm3,pred_rf_svm4,pred_rf_svm5,pred_rf_svm6,pred_rf_svm7,pred_rf_svm8,pred_rf_svm9,pred_rf_svm10)
pred_rf_rf <- rbind(pred_rf_rf1,pred_rf_rf2,pred_rf_rf3,pred_rf_rf4,pred_rf_rf5,pred_rf_rf6,pred_rf_rf7,pred_rf_rf8,pred_rf_rf9,pred_rf_rf10)

results_lasso_ridge[dd,1] <- MLmetrics::AUC(pred_lasso_ridge[,1], pred_lasso_ridge[,2])
results_lasso_ridge[dd,2:12] <- confusionMatrix(data=as.factor(pred_lasso_ridge[,1]), as.factor(pred_lasso_ridge[,2]))$byClass
try(results_lasso_ridge[dd,12] <- mean(as.numeric(lasso_ridge_thresh),na.rm=TRUE))
results_lasso_svm[dd,1] <- MLmetrics::AUC(pred_lasso_svm[,1], pred_lasso_svm[,2])
results_lasso_svm[dd,2:12] <- confusionMatrix(data=as.factor(pred_lasso_svm[,1]), as.factor(pred_lasso_svm[,2]))$byClass
try(results_lasso_svm[dd,12] <- mean(as.numeric(lasso_svm_thresh),na.rm=TRUE))
results_lasso_rf[dd,1] <- MLmetrics::AUC(pred_lasso_rf[,1], pred_lasso_rf[,2])
results_lasso_rf[dd,2:12] <- confusionMatrix(data=as.factor(pred_lasso_rf[,1]), as.factor(pred_lasso_rf[,2]))$byClass
try(results_lasso_rf[dd,12] <- mean(as.numeric(lasso_rf_thresh),na.rm=TRUE))

results_stir_ridge[dd,1] <- MLmetrics::AUC(pred_stir_ridge[,1], pred_stir_ridge[,2])
results_stir_ridge[dd,2:12] <- confusionMatrix(data=as.factor(pred_stir_ridge[,1]), as.factor(pred_stir_ridge[,2]))$byClass
try(results_stir_ridge[dd,12] <- mean(as.numeric(stir_ridge_thresh),na.rm=TRUE))
results_stir_svm[dd,1] <- MLmetrics::AUC(pred_stir_svm[,1], pred_stir_svm[,2])
results_stir_svm[dd,2:12] <- confusionMatrix(data=as.factor(pred_stir_svm[,1]), as.factor(pred_stir_svm[,2]))$byClass
try(results_stir_svm[dd,12] <- mean(as.numeric(stir_svm_thresh),na.rm=TRUE))
results_stir_rf[dd,1] <- MLmetrics::AUC(pred_stir_rf[,1], pred_stir_rf[,2])
results_stir_rf[dd,2:12] <- confusionMatrix(data=as.factor(pred_stir_rf[,1]), as.factor(pred_stir_rf[,2]))$byClass
try(results_stir_rf[dd,12] <- mean(as.numeric(stir_rf_thresh),na.rm=TRUE))

results_rf_ridge[dd,1] <- MLmetrics::AUC(pred_rf_ridge[,1], pred_rf_ridge[,2])
results_rf_ridge[dd,2:12] <- confusionMatrix(data=as.factor(pred_rf_ridge[,1]), as.factor(pred_rf_ridge[,2]))$byClass
try(results_rf_ridge[dd,12] <- mean(as.numeric(rf_ridge_thresh),na.rm=TRUE))
results_rf_svm[dd,1] <- MLmetrics::AUC(pred_rf_svm[,1], pred_rf_svm[,2])
results_rf_svm[dd,2:12] <- confusionMatrix(data=as.factor(pred_rf_svm[,1]), as.factor(pred_rf_svm[,2]))$byClass
try(results_rf_svm[dd,12] <- mean(as.numeric(rf_svm_thresh),na.rm=TRUE))
results_rf_rf[dd,1] <- MLmetrics::AUC(pred_rf_rf[,1], pred_rf_rf[,2])
results_rf_rf[dd,2:12] <- confusionMatrix(data=as.factor(pred_rf_rf[,1]), as.factor(pred_rf_rf[,2]))$byClass
try(results_rf_rf[dd,12] <- mean(as.numeric(rf_rf_thresh),na.rm=TRUE))
}

results_lasso_ridge <- data.frame(results_lasso_ridge,"results_lasso_ridge")
results_lasso_svm <- data.frame(results_lasso_svm,"results_lasso_svm")
results_lasso_rf <- data.frame(results_lasso_rf,"results_lasso_rf")
results_stir_ridge <- data.frame(results_stir_ridge,"results_stir_ridge")
results_stir_svm <- data.frame(results_stir_svm,"results_stir_svm")
results_stir_rf <- data.frame(results_stir_rf,"results_stir_rf")
results_rf_ridge <- data.frame(results_rf_ridge,"results_rf_ridge")
results_rf_svm <- data.frame(results_rf_svm,"results_rf_svm")
results_rf_rf <- data.frame(results_rf_rf,"results_rf_rf")

colnames(results_lasso_ridge) <- c("AUC","Sens","Spec","PPV","NPV","Precision","Recall","F1","Prevalence","DetectionRate","DetectionPrevalence","Threshold","Condition")
colnames(results_lasso_svm) <- colnames(results_lasso_ridge)
colnames(results_lasso_rf) <- colnames(results_lasso_ridge)
colnames(results_stir_ridge) <- colnames(results_lasso_ridge)
colnames(results_stir_svm) <- colnames(results_lasso_ridge)
colnames(results_stir_rf) <- colnames(results_lasso_ridge)
colnames(results_rf_ridge) <- colnames(results_lasso_ridge)
colnames(results_rf_svm) <- colnames(results_lasso_ridge)
colnames(results_rf_rf) <- colnames(results_lasso_ridge)

results <- rbind(
results_lasso_ridge,
results_lasso_svm,
results_lasso_rf,
results_stir_ridge,
results_stir_svm, 
results_stir_rf,
results_rf_ridge,
results_rf_svm,
results_rf_rf)

write.csv(results,"Risk_Calculator_Simulation_Results2.csv",na="")
write.csv(lasso_picked,"Risk_Calculator_lasso_picked2.csv",na="")
write.csv(stir_picked,"Risk_Calculator_stir_picked2.csv",na="")
write.csv(rf_picked,"Risk_Calculator_rf_picked2.csv",na="")


